package com.huimv.manage.util;

import org.springframework.stereotype.Component;

import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
public class DataUtil {

    //解析日期
    public Date parseDate(String date) throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.parse(sdf.format(sdf.parse(date).getTime()));
    }

    //解析日期和时间
    public Date parseDateTime(String dateTime) throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        SimpleDateFormat sdfmat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdfmat.parse(sdfmat.format(sdf.parse(dateTime).getTime()));
    }

    public String formatLongTime(Long dateLong){
        Date date =new Date(dateLong);//以1429339937748为bai毫秒数du实例化zhi一个Date对象dao
        SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");//设置转化格式
        String time=sdf.format(date);//将Date对象转化为yyyy-MM-dd形式的字符串zhuan
        System.out.println(time);//输出字符串
        return time;
    }

    public String formatLongTimeForTime(Long dateLong){
        Date date =new Date(dateLong);//以1429339937748为bai毫秒数du实例化zhi一个Date对象dao
        SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd_HH:mm:ss");//设置转化格式
        String time=sdf.format(date);//将Date对象转化为yyyy-MM-dd形式的字符串zhuan
        System.out.println(time);//输出字符串
        return time;
    }

    public String formatTimestamp(Timestamp timestamp) {
        DateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        //方法一
        return sdf.format(timestamp);
    }

    public String formatLongTimeToImageName(Long dateLong){
        Date date =new Date(dateLong);//以1429339937748为bai毫秒数du实例化zhi一个Date对象dao
        SimpleDateFormat sdf=new SimpleDateFormat("yyyy_MM_dd_HH_mm_ss");//设置转化格式
        String time=sdf.format(date);//将Date对象转化为yyyy-MM-dd形式的字符串zhuan
        System.out.println(time);//输出字符串
        return time;
    }
}
