package com.huimv.manage.util;

import com.huimv.manage.eartag.dao.entity.EtEarmarkEntity;
import org.apache.commons.compress.archivers.ArchiveException;
import org.apache.commons.compress.archivers.ArchiveOutputStream;
import org.apache.commons.compress.archivers.ArchiveStreamFactory;
import org.apache.commons.compress.archivers.zip.ZipArchiveEntry;
import org.apache.commons.compress.archivers.zip.ZipArchiveOutputStream;
import org.apache.commons.io.FileUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
public class TxtUtil {
    @Autowired
    private DataUtil dateUtil;

    public void exportEarmarkToTxt(HttpServletResponse response, String applyId, List<EtEarmarkEntity> dataList, Integer quantity, HttpServletRequest request) throws IOException, ArchiveException {
        //定义根路径
        String rootPath = request.getRealPath("/");
        String basePath = rootPath + "temp_download";
        System.out.println("basePath>>" + basePath);
        //创建文件
        File file = new File(basePath);
        //判断文件是否存在，如果不存在，则创建此文件夹
        System.out.println("file.exists() 11.>>" + file.exists());
        if (!file.exists()) {
            file.mkdir();
        }
        //
        List rootList = new ArrayList();
        List newList = new ArrayList();
        for(int a=0;a<dataList.size();a++) {
            if(a % quantity == 0){
                newList = new ArrayList();
                rootList.add(newList);
                EtEarmarkEntity EtEarmarkEntity = dataList.get(a);
                String earmark = EtEarmarkEntity.getEarmarkNumber()+" "+EtEarmarkEntity.getEarmarkData();
                newList.add(earmark);
            }else{
                EtEarmarkEntity EtEarmarkEntity = dataList.get(a);
                String earmark = EtEarmarkEntity.getEarmarkNumber()+" "+EtEarmarkEntity.getEarmarkData();
                newList.add(earmark);
            }
        }
        System.out.println("rootList.size>>"+rootList.size());
        //写入文件
        List<File> txtList = new ArrayList();
        for(int a=0;a<rootList.size();a++){
            List childDataList = (ArrayList) rootList.get(a);
            //生成新文件并写入耳标数据
            File txtFile = createFileAndWriteText(childDataList,quantity,a+1,basePath);
            txtList.add(txtFile);
        }
        ///////////////////////////////////////////////////////////////////////////////////////////////////////
        String name = "耳标文件压缩包下载";
        String fileName = name + "_" + dateUtil.formatLongTimeForTime(new Date().getTime());
        String zipFileName = fileName + ".zip";
//        File zipFile = null;
//        String path = rootPath + "temp_download";
        // 打成压缩包
        File zipFile = new File(basePath + "/" + zipFileName);
        System.out.println("zipFile.getAbsolutePath>>"+zipFile.getAbsolutePath());
        FileOutputStream zipFos = new FileOutputStream(zipFile);
        ArchiveOutputStream archOut = new ArchiveStreamFactory().createArchiveOutputStream(ArchiveStreamFactory.ZIP, zipFos);
        if (archOut instanceof ZipArchiveOutputStream) {
            ZipArchiveOutputStream zos = (ZipArchiveOutputStream) archOut;
            for (File txtFile : txtList) {
                ZipArchiveEntry zipEntry = new ZipArchiveEntry(txtFile, txtFile.getName());
                zos.putArchiveEntry(zipEntry);
                zos.write(FileUtils.readFileToByteArray(txtFile));
                zos.closeArchiveEntry();
                zos.flush();
            }
            zos.close();
        }
        // 输出到客户端
        OutputStream out = null;
        out = response.getOutputStream();
        response.reset();
        response.setHeader("Content-Disposition", "attachment;filename=" + new String(zipFileName.getBytes("GB2312"), "ISO-8859-1"));
        response.setContentType("application/octet-stream; charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        out.write(FileUtils.readFileToByteArray(zipFile));
        out.flush();
        out.close();

        System.out.println("zipFile.exists()>>"+zipFile.exists());
        // 输出客户端结束后，删除压缩包
//        if (zipFile.exists()) {
//            zipFile.delete();
//        }
    }

    //创建文件并写入耳标数据
    private File createFileAndWriteText(List childDataList,Integer quantity,Integer pageNo,String basePath) throws IOException {
        System.out.println(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>> 新建文件 >>"+pageNo);
        File txtFile = new File(basePath + "/耳标数据第"+pageNo+"页.txt");
        if (!txtFile.exists()) {
            // t1File.delete();
            txtFile.createNewFile();
        }
        System.out.println("txtFile.exists()>>"+txtFile.exists());
        BufferedWriter bw = new BufferedWriter(new FileWriter(txtFile));
        for(int a=0;a<childDataList.size();a++){
            bw.write(childDataList.get(a).toString());
            //换行
            bw.newLine();
        }
        //关闭流
        bw.close();
        System.out.println("第"+pageNo+"页已经写入记录数>>"+childDataList.size());
        return txtFile;
    }

    //导出空数据文件
    public void exportEmptyEarmarkToTxt(HttpServletResponse response, String valueOf, HttpServletRequest request) throws IOException, ArchiveException {
        //定义根路径
        //Linux
        String rootPath = request.getRealPath("/");
        String basePath = rootPath + "temp_download";
        System.out.println("basePath>>" + basePath);
        //创建文件
        File file = new File(basePath);
        //判断文件是否存在，如果不存在，则创建此文件夹
        if (!file.exists()) {
            file.mkdir();
        }
        File t1File = new File(basePath + "/t1.txt");
        if (!t1File.exists()) {
            // t1File.delete();
            t1File.createNewFile();
        }
        BufferedWriter bw = new BufferedWriter(new FileWriter(t1File));
        String text = "暂无任何耳标数据";
        bw.write(text);
        bw.newLine();  //换行用
        //关闭流
        bw.close();
        List<File> txtList = new ArrayList();
        txtList.add(t1File);
        String name = "耳标文件压缩包下载";
        String fileName = name + "_" + dateUtil.formatLongTimeForTime(new Date().getTime());
        String zipFileName = fileName + ".zip";
        File zipFile = null;
        // 打成压缩包
        zipFile = new File(basePath + "/" + zipFileName);
        FileOutputStream zipFos = new FileOutputStream(zipFile);
        ArchiveOutputStream archOut = new ArchiveStreamFactory().createArchiveOutputStream(ArchiveStreamFactory.ZIP, zipFos);
        if (archOut instanceof ZipArchiveOutputStream) {
            ZipArchiveOutputStream zos = (ZipArchiveOutputStream) archOut;
            for (File txtFile : txtList) {
                ZipArchiveEntry zipEntry = new ZipArchiveEntry(txtFile, txtFile.getName());
                zos.putArchiveEntry(zipEntry);
                zos.write(FileUtils.readFileToByteArray(txtFile));
                zos.closeArchiveEntry();
                zos.flush();
            }
            zos.close();
        }
        // 输出到客户端
        OutputStream out = null;
        out = response.getOutputStream();
        response.reset();
        response.setHeader("Content-Disposition", "attachment;filename=" + new String(zipFileName.getBytes("GB2312"), "ISO-8859-1"));
        response.setContentType("application/octet-stream; charset=utf-8");
        response.setCharacterEncoding("UTF-8");
        out.write(FileUtils.readFileToByteArray(zipFile));
        out.flush();
        out.close();

        System.out.println("zipFile.exists()>>"+zipFile.exists());
        // 输出客户端结束后，删除压缩包
        if (zipFile.exists()) {
            zipFile.delete();
        }
    }
}
